/*

    File: Main.cpp

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include "landscape.h"
#include "../m_system3d/main.h"
#include "../m_foundation/main.h"

static void Kix(void) {
	BOOL (*wglSwapIntervalEXT)(int interval) = NULL;
	int (*wglGetSwapIntervalEXT)(void) = NULL;

	if (!main_display->HasExtension("WGL_EXT_swap_control")) {
		main_console->Print("didnt find extension WGL_EXT_swap_control\n");
		return;
	} else {
		wglSwapIntervalEXT			= (BOOL (__cdecl *)(int))		wglGetProcAddress("wglSwapIntervalEXT");
		wglGetSwapIntervalEXT		= (int (__cdecl *)(void))		wglGetProcAddress("wglGetSwapIntervalEXT");

		if (wglSwapIntervalEXT &&
			wglGetSwapIntervalEXT) {
			main_console->Print("found GL extension WGL_EXT_swap_control\n");
			main_console->Print("current swap interval: %d\n", wglGetSwapIntervalEXT());
			wglSwapIntervalEXT(0);
			main_console->Print("new swap interval: %d\n", wglGetSwapIntervalEXT());
		} else {
			main_console->Print("funcs found to be NULL\n");
		}
	}
}

bool Init_Application3D(void) {

	Kix();

	overrideCameraKeys = 1;
	main_console->SetIdleVisible(false);

	CVar_Exec("ConsoleFont font.bmp");
	CVar_Exec("CamZNear .1");
	CVar_Exec("camSpeed .1");

	if (!landscapeInit()) return false;
	return true;
}

void Update_Application3D(void) {

	//input - for kicks =) 
	if (main_keyboard->keystate[VK_SHIFT]) {
		if (main_keyboard->keystate[VkKeyScan('!')])	overrideCameraRot = 3.f*0.1f;
		if (main_keyboard->keystate[VkKeyScan('@')])	overrideCameraRot = 3.f*3.f*0.25f;
		if (main_keyboard->keystate[VkKeyScan('#')])	overrideCameraRot = 3.f*0.5f;
		if (main_keyboard->keystate[VkKeyScan('$')])	overrideCameraRot = 3.f*1.f;
		if (main_keyboard->keystate[VkKeyScan('%')])	overrideCameraRot = 3.f*2.5f;
		if (main_keyboard->keystate[VkKeyScan('^')])	overrideCameraRot = 3.f*5.f;
		if (main_keyboard->keystate[VkKeyScan('&')])	overrideCameraRot = 3.f*10.f;
		if (main_keyboard->keystate[VkKeyScan('*')])	overrideCameraRot = 3.f*25.f;
		if (main_keyboard->keystate[VkKeyScan('(')])	overrideCameraRot = 3.f*50.f;
		if (main_keyboard->keystate[VkKeyScan(')')])	overrideCameraRot = 3.f*100.f;
	} else {
		if (main_keyboard->keystate[VkKeyScan('1')])	overrideCameraSpeed = 0.075f;
		if (main_keyboard->keystate[VkKeyScan('2')])	overrideCameraSpeed = 0.1f;
		if (main_keyboard->keystate[VkKeyScan('3')])	overrideCameraSpeed = 0.25f;
		if (main_keyboard->keystate[VkKeyScan('4')])	overrideCameraSpeed = 0.5f;
		if (main_keyboard->keystate[VkKeyScan('5')])	overrideCameraSpeed = 0.75f;
		if (main_keyboard->keystate[VkKeyScan('6')])	overrideCameraSpeed = 1.f;
		if (main_keyboard->keystate[VkKeyScan('7')])	overrideCameraSpeed = 2.5f;
		if (main_keyboard->keystate[VkKeyScan('8')])	overrideCameraSpeed = 5.f;
		if (main_keyboard->keystate[VkKeyScan('9')])	overrideCameraSpeed = 7.5f;
		if (main_keyboard->keystate[VkKeyScan('0')])	overrideCameraSpeed = 10.f;
	}

	//render
	landscapeUpdate();
}

void Shutdown_Application3D(void) {
	landscapeShutdown();
}